# cythereal-dashboard
 The API used exclusively by the MAGIC Dashboard for populating charts, graphs, tables, etc... on the dashboard.  # API Conventions  **All responses** MUST be of type `APIResponse` and contain the following fields:  * `api_version` |  The current api version * `success` | Boolean value indicating if the operation succeeded. * `code` | Status code. Typically corresponds to the HTTP status code.  * `message` | A human readable message providing more details about the operation. Can be null or empty.  **Successful operations** MUST return a `SuccessResponse`, which extends `APIResponse` by adding:  * `data` | Properties containing the response object. * `success` | MUST equal True  When returning objects from a successful response, the `data` object SHOULD contain a property named after the requested object type. For example, the `/alerts` endpoint should return a response object with `data.alerts`. This property SHOULD  contain a list of the returned objects. For the `/alerts` endpoint, the `data.alerts` property contains a list of MagicAlerts objects. See the `/alerts` endpoint documentation for an example.  **Failed Operations** MUST return an `ErrorResponse`, which extends `APIResponse` by adding:  * `success` | MUST equal False. 

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 0.36.1
- Package version: 0.36.1
- Build package: io.swagger.codegen.languages.PythonClientCodegen
For more information, please visit [https://cythereal.com](https://cythereal.com)

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import cythereal_dashboard 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import cythereal_dashboard
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import cythereal_dashboard
from cythereal_dashboard.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_key_query_param
configuration = cythereal_dashboard.Configuration()
configuration.api_key['key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['key'] = 'Bearer'

# create an instance of the API class
api_instance = cythereal_dashboard.DashboardApi(cythereal_dashboard.ApiClient(configuration))
start_date = '1999-01-01' # str | Return counts from the given date until endDate. Specify date as `YYYY-MM-DD`.  (optional) (default to 1999-01-01)
end_date = '9999-12-31' # str | Return counts from startDate until the given date. Specify date as `YYYY-MM-DD`.        (optional) (default to 9999-12-31)
all_files = false # bool |  (optional) (default to false)
children_only = false # bool |  (optional) (default to false)
files_only = false # bool |  (optional) (default to false)
file_type = 'file_type_example' # str |  (optional)
children_file_type = 'children_file_type_example' # str |  (optional)

try:
    # Get the users total number of binaries, campaigns, and tags
    api_response = api_instance.get_counts(start_date=start_date, end_date=end_date, all_files=all_files, children_only=children_only, files_only=files_only, file_type=file_type, children_file_type=children_file_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DashboardApi->get_counts: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.magic.cythereal.com/dashboard*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DashboardApi* | [**get_counts**](docs/DashboardApi.md#get_counts) | **GET** /info/counts/ | Get the users total number of binaries, campaigns, and tags
*EmailsApi* | [**get_owned_email_binaries**](docs/EmailsApi.md#get_owned_email_binaries) | **GET** /emails/binaries/ | List Binaries found in emails owned by the authenticated user.
*EmailsApi* | [**get_owned_email_children**](docs/EmailsApi.md#get_owned_email_children) | **GET** /emails/children/ | List Children found in emails owned by the authenticated user.
*EmailsApi* | [**get_owned_emails**](docs/EmailsApi.md#get_owned_emails) | **GET** /emails/ | List emails owned by the authenticated user.
*EmailsApi* | [**list_email_data**](docs/EmailsApi.md#list_email_data) | **POST** /emails/emaildata/ | Takes a list of email hashes and returns a list of their emaildata
*FilesApi* | [**add_binary**](docs/FilesApi.md#add_binary) | **POST** /files/add/ | Add public binaries to your account
*FilesApi* | [**create_file**](docs/FilesApi.md#create_file) | **POST** /files/ | Upload a file for processing
*FilesApi* | [**download_file**](docs/FilesApi.md#download_file) | **GET** /files/{file_hash} | Download a file
*FilesApi* | [**get_file_details**](docs/FilesApi.md#get_file_details) | **GET** /files/{file_hash}/details | Get additional details about certain filetypes
*FilesApi* | [**get_file_info**](docs/FilesApi.md#get_file_info) | **GET** /files/{file_hash}/info/ | Get file info and analysis status
*FilesApi* | [**get_file_status**](docs/FilesApi.md#get_file_status) | **GET** /files/{file_hash}/status/ | Get processing status of the file.
*FilesApi* | [**get_owned_files**](docs/FilesApi.md#get_owned_files) | **GET** /files/ | List files owned by the authenticated user.
*FilesApi* | [**list_av_data**](docs/FilesApi.md#list_av_data) | **POST** /files/avdata/ | Takes a list of hashes and returns a list of their avdata
*FilesApi* | [**list_binary_data**](docs/FilesApi.md#list_binary_data) | **POST** /files/binarydata/ | Takes a list of hashes and returns a list of their match and label data
*FilesApi* | [**remove_file**](docs/FilesApi.md#remove_file) | **GET** /files/{file_hash}/remove | Remove a top level file from the user&#39;s account
*FilesApi* | [**reprocess_file**](docs/FilesApi.md#reprocess_file) | **GET** /files/{file_hash}/reprocess/ | Reprocess a previously uploaded file
*IocsApi* | [**list_iocs**](docs/IocsApi.md#list_iocs) | **GET** /iocs/ | Gets the iocs that belong to the user
*ReportsApi* | [**get_archive_report**](docs/ReportsApi.md#get_archive_report) | **GET** /reports/{file_hash}/archive/ | Gets the full report of a container type file
*ReportsApi* | [**get_email_report**](docs/ReportsApi.md#get_email_report) | **GET** /reports/{email_id}/email/ | Retrieve the MAGIC matches for a binary.
*ReportsApi* | [**get_html_report**](docs/ReportsApi.md#get_html_report) | **GET** /reports/{file_hash}/html/ | Retrieve the html report for an html file
*ReportsApi* | [**get_procedures_report**](docs/ReportsApi.md#get_procedures_report) | **POST** /procedures/{proc_hash}/report | Generate the report for the given procedures
*ReportsApi* | [**get_report**](docs/ReportsApi.md#get_report) | **GET** /reports/{file_hash}/ | Get the Magic report for a binary.
*ReportsApi* | [**list_file_matches**](docs/ReportsApi.md#list_file_matches) | **POST** /reports/{file_hash}/matches/ | Retrieve the MAGIC matches for a binary.
*ReprocessApi* | [**reprocess_avscan**](docs/ReprocessApi.md#reprocess_avscan) | **GET** /reprocess/{file_hash}/avscan/ | Sends the given file off for avscan reprocessing
*ReprocessApi* | [**reprocess_matches**](docs/ReprocessApi.md#reprocess_matches) | **GET** /reprocess/{file_hash}/matches/ | Sends the given file off for match reprocessing
*SignaturesApi* | [**get_magic_yara**](docs/SignaturesApi.md#get_magic_yara) | **GET** /signatures/magic_yara/ | \&quot;Generate a yara rule, and campaign information for  the provided binaries.\&quot; 
*SignaturesApi* | [**get_procedure_signatures**](docs/SignaturesApi.md#get_procedure_signatures) | **GET** /signatures/procedures/ | Generate procedure signatures for provided binaries.
*WorkspacesApi* | [**add_tag**](docs/WorkspacesApi.md#add_tag) | **POST** /workspaces/add/ | Adds a tag to the workspace
*WorkspacesApi* | [**color_workspace**](docs/WorkspacesApi.md#color_workspace) | **POST** /workspaces/color/ | Change the color of the workspace
*WorkspacesApi* | [**create_workspace**](docs/WorkspacesApi.md#create_workspace) | **POST** /workspaces/ | Creates a new workspace for the user
*WorkspacesApi* | [**delete_all_workspaces**](docs/WorkspacesApi.md#delete_all_workspaces) | **GET** /workspaces/delete_all/ | Deletes all of the user&#39;s workspaces
*WorkspacesApi* | [**delete_workspace**](docs/WorkspacesApi.md#delete_workspace) | **POST** /workspaces/delete/ | Deletes a specific workspace
*WorkspacesApi* | [**empty_workspace**](docs/WorkspacesApi.md#empty_workspace) | **POST** /workspaces/empty | Removes all objects from a workspace
*WorkspacesApi* | [**get_workspace**](docs/WorkspacesApi.md#get_workspace) | **POST** /workspaces/{workspace_name}/ | Retrieves a specific workspace for a user
*WorkspacesApi* | [**list_collection_tags**](docs/WorkspacesApi.md#list_collection_tags) | **POST** /workspaces/collection/ | Returns all of the user&#39;s tags in a given collection
*WorkspacesApi* | [**list_workspaces**](docs/WorkspacesApi.md#list_workspaces) | **GET** /workspaces/ | Gets all the user&#39;s workspaces
*WorkspacesApi* | [**merge_workspace**](docs/WorkspacesApi.md#merge_workspace) | **POST** /workspaces/merge/ | Merges two workspaces into a single one
*WorkspacesApi* | [**remove_tag**](docs/WorkspacesApi.md#remove_tag) | **POST** /workspaces/remove/ | Removes a tag from a workspace
*WorkspacesApi* | [**rename_workspace**](docs/WorkspacesApi.md#rename_workspace) | **POST** /workspaces/rename/ | Renames a workspace and it&#39;s collection
*WorkspacesApi* | [**tag_file**](docs/WorkspacesApi.md#tag_file) | **POST** /workspaces/tag_file/ | Adds a tag to a file object


## Documentation For Models

 - [Analysis](docs/Analysis.md)
 - [AnalysisInner](docs/AnalysisInner.md)
 - [ApiResponse](docs/ApiResponse.md)
 - [ArchiveReport](docs/ArchiveReport.md)
 - [AvNames](docs/AvNames.md)
 - [Categories](docs/Categories.md)
 - [Category](docs/Category.md)
 - [ChildInfo](docs/ChildInfo.md)
 - [CollectionModel](docs/CollectionModel.md)
 - [DetectionStats](docs/DetectionStats.md)
 - [EmailChildObject](docs/EmailChildObject.md)
 - [EmailChildObjectTopLevelFiles](docs/EmailChildObjectTopLevelFiles.md)
 - [EmailChildrenList](docs/EmailChildrenList.md)
 - [EmailChildrenListInner](docs/EmailChildrenListInner.md)
 - [EmailDataList](docs/EmailDataList.md)
 - [EmailDataListInner](docs/EmailDataListInner.md)
 - [EmailObject](docs/EmailObject.md)
 - [EmailObjectEmailChildren](docs/EmailObjectEmailChildren.md)
 - [EmailObjectFileChildren](docs/EmailObjectFileChildren.md)
 - [EmailObjectIocObjects](docs/EmailObjectIocObjects.md)
 - [EmailsList](docs/EmailsList.md)
 - [EmailsListInner](docs/EmailsListInner.md)
 - [EmailsListInnerDescendants](docs/EmailsListInnerDescendants.md)
 - [EmailsResponseData](docs/EmailsResponseData.md)
 - [Evasiveness](docs/Evasiveness.md)
 - [Families](docs/Families.md)
 - [FamiliesInner](docs/FamiliesInner.md)
 - [Family](docs/Family.md)
 - [FileAVDataList](docs/FileAVDataList.md)
 - [FileAVDataListInner](docs/FileAVDataListInner.md)
 - [FileAdded](docs/FileAdded.md)
 - [FileBinaryDataList](docs/FileBinaryDataList.md)
 - [FileBinaryDataListInner](docs/FileBinaryDataListInner.md)
 - [FileInfo](docs/FileInfo.md)
 - [FileObject](docs/FileObject.md)
 - [FileStatus](docs/FileStatus.md)
 - [FileUploadResponseData](docs/FileUploadResponseData.md)
 - [Filename](docs/Filename.md)
 - [FilesList](docs/FilesList.md)
 - [FilesListFiles](docs/FilesListFiles.md)
 - [Filetype](docs/Filetype.md)
 - [HTMLObject](docs/HTMLObject.md)
 - [InfoCountsResponseData](docs/InfoCountsResponseData.md)
 - [IocsList](docs/IocsList.md)
 - [IocsListIocs](docs/IocsListIocs.md)
 - [IsGroup](docs/IsGroup.md)
 - [IsOwned](docs/IsOwned.md)
 - [IsPublic](docs/IsPublic.md)
 - [IsUser](docs/IsUser.md)
 - [Labels](docs/Labels.md)
 - [LabelsInner](docs/LabelsInner.md)
 - [MagicMatches](docs/MagicMatches.md)
 - [MagicMatchesMatchSubtypes](docs/MagicMatchesMatchSubtypes.md)
 - [MagicMatchesMatches](docs/MagicMatchesMatches.md)
 - [MagicReport](docs/MagicReport.md)
 - [MagicYaraResponseData](docs/MagicYaraResponseData.md)
 - [Md5](docs/Md5.md)
 - [NameWithCollection](docs/NameWithCollection.md)
 - [NameWithColor](docs/NameWithColor.md)
 - [NameWithHash](docs/NameWithHash.md)
 - [NameWithTags](docs/NameWithTags.md)
 - [Names](docs/Names.md)
 - [NumMatches](docs/NumMatches.md)
 - [ObjectClass](docs/ObjectClass.md)
 - [OldCategories](docs/OldCategories.md)
 - [OldCategoriesDirect](docs/OldCategoriesDirect.md)
 - [OldCategoriesInferred](docs/OldCategoriesInferred.md)
 - [ProcedureInfoList](docs/ProcedureInfoList.md)
 - [ProcedureInfoListInner](docs/ProcedureInfoListInner.md)
 - [ProcedureInfoListInnerBlocks](docs/ProcedureInfoListInnerBlocks.md)
 - [ProcedureReportResponseData](docs/ProcedureReportResponseData.md)
 - [ProcedureSignature](docs/ProcedureSignature.md)
 - [ProcedureSignatures](docs/ProcedureSignatures.md)
 - [Sha1](docs/Sha1.md)
 - [Sha256](docs/Sha256.md)
 - [Sha512](docs/Sha512.md)
 - [Status](docs/Status.md)
 - [TagModel](docs/TagModel.md)
 - [Tags](docs/Tags.md)
 - [Timestamp](docs/Timestamp.md)
 - [Tokens](docs/Tokens.md)
 - [Unmapped](docs/Unmapped.md)
 - [WorkspaceList](docs/WorkspaceList.md)
 - [WorkspaceModel](docs/WorkspaceModel.md)
 - [ErrorResponse](docs/ErrorResponse.md)
 - [SuccessResponse](docs/SuccessResponse.md)
 - [ArchiveReportResponse](docs/ArchiveReportResponse.md)
 - [CollectionResponse](docs/CollectionResponse.md)
 - [EmailChildrenResponse](docs/EmailChildrenResponse.md)
 - [EmailDataListReponse](docs/EmailDataListReponse.md)
 - [EmailResponse](docs/EmailResponse.md)
 - [EmailsResponse](docs/EmailsResponse.md)
 - [FileAVDataListResponse](docs/FileAVDataListResponse.md)
 - [FileBinaryDataListResponse](docs/FileBinaryDataListResponse.md)
 - [FileDetailsResponse](docs/FileDetailsResponse.md)
 - [FileInfoResponse](docs/FileInfoResponse.md)
 - [FileStatusResponse](docs/FileStatusResponse.md)
 - [FileUploadResponse](docs/FileUploadResponse.md)
 - [FilesAddedResponse](docs/FilesAddedResponse.md)
 - [HTMLResponse](docs/HTMLResponse.md)
 - [InfoCountsResponse](docs/InfoCountsResponse.md)
 - [InvalidApiKey](docs/InvalidApiKey.md)
 - [IocsListResponse](docs/IocsListResponse.md)
 - [MagicMatchesResponse](docs/MagicMatchesResponse.md)
 - [MagicReportResponse](docs/MagicReportResponse.md)
 - [MagicYaraResponse](docs/MagicYaraResponse.md)
 - [MissingParameter](docs/MissingParameter.md)
 - [ObjectAlreadyExists](docs/ObjectAlreadyExists.md)
 - [ObjectNotFound](docs/ObjectNotFound.md)
 - [OwnedFilesListResponse](docs/OwnedFilesListResponse.md)
 - [ProcedureReportResponse](docs/ProcedureReportResponse.md)
 - [ProcedureSignaturesResponse](docs/ProcedureSignaturesResponse.md)
 - [UnauthorizedApiKey](docs/UnauthorizedApiKey.md)
 - [WorkspaceCreatedResponse](docs/WorkspaceCreatedResponse.md)
 - [WorkspaceListResponse](docs/WorkspaceListResponse.md)
 - [WorkspaceResponse](docs/WorkspaceResponse.md)


## Documentation For Authorization


## api_key_query_param

- **Type**: API key
- **API key parameter name**: key
- **Location**: URL query string


## Author

support@cythereal.com

